#include "staff.h"

int staff::Rotate(stage* pStage){
  char n;
  char ini_st=Style;
  for(n=0,Style+=1;n<3;n++,Style++){
    if(Style>3) Style=0;
    if(CheckBlockRotation(pStage,Style)==0) return 0;
  }
  if(n>=3) Style=ini_st;
  return -1;
}

int staff::GoRight(stage* pStage){
  if(CheckBlock(pStage,1,0)==-1) return -1;
  centre_r++;
  return 0;
}

int staff::GoLeft(stage* pStage){
  if(CheckBlock(pStage,-1,0)==-1) return -1;
  centre_r--;
  return 0;
}

int staff::CheckBlock(stage* pStage,char r_diff,char c_diff){
  if(pStage->ReferFilledArray(centre_r+r_diff,centre_c+c_diff)==true) return -1;
  for(char n=0;n<3;n++){
    if(pStage->ReferFilledArray(centre_r+StyleInfo[Style][n][0]+r_diff,centre_c+StyleInfo[Style][n][1]+c_diff)==true) return -1;
  }
  return 0;
}

int staff::CheckBlockRotation(stage* pStage,char stylenum){
  for(char n=0;n<3;n++){
    if(pStage->ReferFilledArray(centre_r+StyleInfo[stylenum][n][0],centre_c+StyleInfo[stylenum][n][1])==true) return -1;
  }
  return 0;
}

staff::staff(){
#define DISPLAY_ROW 16
#define DISPLAY_COLUMN 15
#define DISPLAY_OFFSET_X 3
#define DISPLAY_OFFSET_Y 1
  Style=0;
  lF=1;
  InitializeRotationMATRIX();
  PosXDisplay=DISPLAY_ROW+DISPLAY_OFFSET_X;
  PosYDisplay=DISPLAY_COLUMN+DISPLAY_OFFSET_Y;

  for(char i=0;i<4;i++){
    for(char j=0;j<3;j++){
      for(char k=0;k<2;k++){
	StyleInfo[i][j][k]=0;
      }
    }
  }
}

int staff::InitializeRotationMATRIX(){
  RotationMATRIX[0][0]=0;
  RotationMATRIX[0][1]=-1;
  RotationMATRIX[1][0]=1;
  RotationMATRIX[1][1]=0;
  return 0;
}

int  staff::GoToNext(stage* pStage){
  if(CheckBlock(pStage,0,-1)==-1) return -1;
  centre_c--;
  return 0;
}

int staff::DrawStaff(){
#define BLOCK_OGN 8
  GWsetogn(0,-lF+BLOCK_OGN);
  pBlock->ShowBlock(centre_r,centre_c);
  for(char n=0;n<3;n++){
    pBlock->ShowBlock(centre_r+StyleInfo[Style][n][0],centre_c+StyleInfo[Style][n][1]);
  }
  GWerase(lF+BLOCK_OGN,1);
  lF*=-1;
  return 0;
}

void staff::EraseThis(void){
  GWerase(lF+BLOCK_OGN,1);
}

int staff::DisplayNext(){
#define BLOCK_OGN_FOR_NEXT 28
  GWsetogn(0,BLOCK_OGN_FOR_NEXT);
  pBlock->ShowBlock(PosXDisplay+BLOCK_OGN_SP_DIFF,PosYDisplay+BLOCK_OGN_SP_DIFFY);
  for(char n=0;n<3;n++){
    pBlock->ShowBlock(PosXDisplay+BLOCK_OGN_SP_DIFF+StyleInfo[Style][n][0],PosYDisplay+BLOCK_OGN_SP_DIFFY+StyleInfo[Style][n][1]);
  }
  return 0;
}

void staff::RemoveDisplay(){
  GWerase(BLOCK_OGN_FOR_NEXT,1);
}

staff1::staff1(){
  pBlock=new block1;
  centre_r=INITIAL_CENTRE_R1;
  centre_c=INITIAL_CENTRE_C1;
  StyleInfo[0][0][0]=-1;
  StyleInfo[0][0][1]=0;
  StyleInfo[0][1][0]=0;
  StyleInfo[0][1][1]=1;
  StyleInfo[0][2][0]=0;
  StyleInfo[0][2][1]=-1;
  SizeMAT=3;
  Rcenter=1;
  Ccenter=1;
  MakeRotatedForm();
  BLOCK_OGN_SP_DIFF=0.5f;
  BLOCK_OGN_SP_DIFFY=-0.5f;
}

staff1::~staff1(){
  delete pBlock;
}

staff2::staff2(){
  pBlock=new block2;
  centre_r=INITIAL_CENTRE_R2;
  centre_c=INITIAL_CENTRE_C2;
  StyleInfo[0][0][0]=-1;
  StyleInfo[0][0][1]=1;
  StyleInfo[0][1][0]=0;
  StyleInfo[0][1][1]=1;
  StyleInfo[0][2][0]=0;
  StyleInfo[0][2][1]=-1;
  SizeMAT=3;
  Rcenter=1;
  Ccenter=1;
  MakeRotatedForm();
  BLOCK_OGN_SP_DIFF=0.5f;
  BLOCK_OGN_SP_DIFFY=-0.5f;
}

staff2::~staff2(){
  delete pBlock;
}

staff3::staff3(){
  pBlock=new block3;
  centre_r=INITIAL_CENTRE_R3;
  centre_c=INITIAL_CENTRE_C3;
  StyleInfo[0][0][0]=1;
  StyleInfo[0][0][1]=1;
  StyleInfo[0][1][0]=0;
  StyleInfo[0][1][1]=1;
  StyleInfo[0][2][0]=0;
  StyleInfo[0][2][1]=-1;
  SizeMAT=3;
  Rcenter=1;
  Ccenter=1;
  MakeRotatedForm();
  BLOCK_OGN_SP_DIFF=-0.5f;
  BLOCK_OGN_SP_DIFFY=-0.5f;
}

staff3::~staff3(){
  delete pBlock;
}

staff4::staff4(){
  pBlock=new block4;
  centre_r=INITIAL_CENTRE_R4;
  centre_c=INITIAL_CENTRE_C4;
  StyleInfo[0][0][0]=1;
  StyleInfo[0][0][1]=0;
  StyleInfo[0][1][0]=1;
  StyleInfo[0][1][1]=1;
  StyleInfo[0][2][0]=0;
  StyleInfo[0][2][1]=1;
  SizeMAT=2;
  Rcenter=1;
  Ccenter=1;
  MakeRotatedForm();
  BLOCK_OGN_SP_DIFF=-0.5f;
  BLOCK_OGN_SP_DIFFY=-1.f;
}

staff4::~staff4(){
  delete pBlock;
}

staff5::staff5(){
  pBlock=new block5;
  centre_r=INITIAL_CENTRE_R5;
  centre_c=INITIAL_CENTRE_C5;
  StyleInfo[0][0][0]=0;
  StyleInfo[0][0][1]=1;
  StyleInfo[0][1][0]=-1;
  StyleInfo[0][1][1]=0;
  StyleInfo[0][2][0]=-1;
  StyleInfo[0][2][1]=-1;
  SizeMAT=3;
  Rcenter=2;
  Ccenter=1;
  MakeRotatedForm();
  memcpy(StyleInfo[2],StyleInfo[0],sizeof(char)*2*3*2);
  BLOCK_OGN_SP_DIFF=0.5f;
  BLOCK_OGN_SP_DIFFY=-0.5f;
}

staff5::~staff5(){
  delete pBlock;
}

staff6::staff6(){
  pBlock=new block6;
  centre_r=INITIAL_CENTRE_R6;
  centre_c=INITIAL_CENTRE_C6;
  StyleInfo[0][0][0]=0;
  StyleInfo[0][0][1]=1;
  StyleInfo[0][1][0]=0;
  StyleInfo[0][1][1]=-1;
  StyleInfo[0][2][0]=0;
  StyleInfo[0][2][1]=-2;
  SizeMAT=4;
  Rcenter=2;
  Ccenter=1;
  MakeRotatedForm();
  memcpy(StyleInfo[2],StyleInfo[0],sizeof(char)*2*3*2);
  BLOCK_OGN_SP_DIFF=0;
  BLOCK_OGN_SP_DIFFY=0;
}

staff6::~staff6(){
  delete pBlock;
}

staff7::staff7(){
  pBlock=new block7;
  centre_r=INITIAL_CENTRE_R7;
  centre_c=INITIAL_CENTRE_C7;
  StyleInfo[0][0][0]=0;
  StyleInfo[0][0][1]=1;
  StyleInfo[0][1][0]=1;
  StyleInfo[0][1][1]=0;
  StyleInfo[0][2][0]=1;
  StyleInfo[0][2][1]=-1;
  SizeMAT=3;
  Rcenter=0;
  Ccenter=1;
  MakeRotatedForm();
  memcpy(StyleInfo[2],StyleInfo[0],sizeof(char)*2*3*2);
  BLOCK_OGN_SP_DIFF=-0.5f;
  BLOCK_OGN_SP_DIFFY=-0.5f;
}

staff7::~staff7(){
  delete pBlock;
}

void staff::MakeRotatedForm(void){
  bool buff[4][4];
  bool tbuff[4][4];
  char rcen,ccen;
  rcen=Rcenter;
  ccen=Ccenter;
  for(char kl=0;kl<3;kl++){
    //Index(kl)StyleInfoMATRIXbuff֕ԂB
    MakeMATRIXfromStyleInfo(kl,buff,rcen,ccen);		//OK
    //buffx,yWɕϊA90xvɉ]یɃXCh
    //̍WAƂ̐}ɒtbuffɂB
    //S̍WXVB
    MultiplyRotationMATRIX(buff,tbuff,&rcen,&ccen);	//OK
    //MATRIX tbuffƂStyleInfo[kl+1]쐬B
    MakeStyleInfoFromMATRIX(tbuff,kl+1,rcen,ccen);
  }
}

void staff::MultiplyRotationMATRIX12(char i,char j,char* x,char* y){
  char k;
  *x=RotationMATRIX[0][0]*i+RotationMATRIX[0][1]*j;
  *y=RotationMATRIX[1][0]*i+RotationMATRIX[1][1]*j;
}

void staff::MakeMATRIXfromStyleInfo(char m,bool lout[][4],char rcen,char ccen){
  for(char i=0;i<4;i++){
    for(char j=0;j<4;j++){
      lout[i][j]=0;
    }
  }
  lout[ccen][rcen]=1;
  for(char i=0;i<3;i++){
    lout[ccen-StyleInfo[m][i][1]][rcen+StyleInfo[m][i][0]]=1;
  }
}

void staff::MultiplyRotationMATRIX(bool lin[][4],bool lout[][4],char* rcen,char* ccen){
  for(char i=0;i<4;i++){
    for(char j=0;j<4;j++){
      lout[i][j]=0;
    }
  }
  char x,y;
  for(char i=0;i<4;i++){
    for(char j=0;j<4;j++){
      if(lin[i][j]){
	MultiplyRotationMATRIX12(j+1,4-i,&x,&y);
	x+=5;
	lout[4-y][x-1]=1;
      }
    }
  }
  MultiplyRotationMATRIX12(*rcen+1,4-*ccen,&x,&y);
  *ccen=4-y;
  *rcen=x+5-1;
}

void staff::MakeStyleInfoFromMATRIX(bool lin[][4],char stylenum,char rcen,char ccen){
  char k=0;
  for(char i=0;i<4;i++){
    for(char j=0;j<4;j++){
      if(lin[i][j]){
	if(i==ccen && j==rcen)continue;
	StyleInfo[stylenum][k][0]=j-rcen;
	StyleInfo[stylenum][k][1]=ccen-i;
	k++;
      }
    }
  }
}

void staff4::MakeRotatedForm(void){
  memcpy(StyleInfo[1],StyleInfo,sizeof(char)*2*3);
  memcpy(StyleInfo[2],StyleInfo,sizeof(char)*2*3);
  memcpy(StyleInfo[3],StyleInfo,sizeof(char)*2*3);
}
