#include "stage.h"
#define TTL 4
#define UPDATE_SPEED_IN_MILLISECONDS 32
#define DEFAULT_CNT_TO_NEXT 32
#define SPEED1 32
#define SPEED2 28
#define SPEED3 26
#define SPEED4 24
#define SPEED5 22
#define SPEED6 20
#define SPEED7 18
#define SPEED8 16
#define SPEED9 14
#define SPEED10 12
#define SPEED11 10
#define SPEED12 8
#define NEXT_CHARA_START_X STAGE_START_X+BLOCK_LENGTH*(ROW+2)+118
#define NEXT_CHARA_START_Y STAGE_START_Y+BLOCK_LENGTH*(COLUMN+2)-48
#define SCORE_CHARA_START_X STAGE_START_X+BLOCK_LENGTH*(ROW+2)+96
#define SCORE_CHARA_START_Y STAGE_START_Y+BLOCK_LENGTH*4
#define INST_CHARA_START_X STAGE_START_X+BLOCK_LENGTH*(ROW+2)+60
#define INST_CHARA_START_Y STAGE_START_Y+BLOCK_LENGTH*0.5
#define NEXT_CHARA_SIZE 32
#define NORMAL_CHARA_SIZE 16
#define LITTLE_CHARA_SIZE 11
#define NORMAL_CHARA_INTERVAL 16
#define LITTLE_CHARA_INTERVAL 6
#define BACK_COLOUR 8,8,8
#define BASE_POINT 12
#define TIMEOGN 17893
#define SCOREOGN 17894
#define LEVELOGN 17895
#define LEVEL_UP_POINTS 128
#define GAMEOVER_CHARA_SIZE 112
#define GAMEOVER_COMMAND_CHARA_SIZE 36
#define GAMEOVER_START_X WINDOW_WIDTH/2
#define GAMEOVER_START_Y STAGE_START_Y+BLOCK_LENGTH*16.5
#define MARGIN_COMMAND_Y -8
#define MARGIN_TIMETOQUIT_Y -108

stage::stage(){
  InitializeIsFilledArray();
  cnt=DEFAULT_CNT_TO_NEXT;
  CntToNext=DEFAULT_CNT_TO_NEXT;
  UpdateSpeedInMilliseconds=UPDATE_SPEED_IN_MILLISECONDS;
  TimePeriod=UPDATE_SPEED_IN_MILLISECONDS;
  Time=0;
  Score=0;
  sec=0;
  min=0;
  Lv=1;
  presec=0;
}

stage::~stage(){
}

void stage::DrawTimeToQuit(char time){
#define SHADOW_VOLUME2 4
#define COLOUR_PEACHPUFF 255,218,185
#define OGN_TIMETOQUIT 24524
  char pbuff[8];
  sprintf(pbuff,"%d",time);
  GWerase(OGN_TIMETOQUIT,1);
  GWsetogn(0,OGN_TIMETOQUIT);
  GWsettxt(GAMEOVER_CHARA_SIZE,0,0,GWC_BLACK,-1,NULL,0);
  GWputtxt(GAMEOVER_START_X+SHADOW_VOLUME2,WINDOW_HEIGHT/2+MARGIN_TIMETOQUIT_Y-SHADOW_VOLUME2,pbuff,0);
  GWsettxt(GAMEOVER_CHARA_SIZE,0,-1,GWkrgb(COLOUR_PEACHPUFF),-1,NULL,0);
  GWputtxt(GAMEOVER_START_X,WINDOW_HEIGHT/2+MARGIN_TIMETOQUIT_Y,pbuff,0);
}

void stage::NoticeGameOver(void){
#define GAMEOVER_BACKCOLOUR_DERAY 16
#define COLOUR_PURPLE 75,0,130 
  GWsetpen(GWkrgb(64,64,64),GWL_SOLID,2,6);
  for(unsigned int i=0;i<WINDOW_HEIGHT-BLOCK_LENGTH*13;i++){
    GWline(BLOCK_LENGTH*2,BLOCK_LENGTH*2+i,WINDOW_WIDTH-BLOCK_LENGTH*2,BLOCK_LENGTH*2+i);
    GWline(BLOCK_LENGTH*2,BLOCK_LENGTH*2+(WINDOW_HEIGHT-BLOCK_LENGTH*4-i),WINDOW_WIDTH-BLOCK_LENGTH*2,BLOCK_LENGTH*2+(WINDOW_HEIGHT-BLOCK_LENGTH*4-i));
    if(!~(~0^(i&3))) Sleep(GAMEOVER_BACKCOLOUR_DERAY);
  }
  GWsettxt(GAMEOVER_CHARA_SIZE,0,0,GWC_BLACK,-1,NULL,0);
#define SHADOW_VOLUME_LARGE_CHARA 6.0
  for(float vl=0;vl<SHADOW_VOLUME_LARGE_CHARA;vl+=0.6){
    GWputtxt(GAMEOVER_START_X+vl,GAMEOVER_START_Y-vl,(char*)"GAME OVER",0);
  }
  GWsettxt(GAMEOVER_CHARA_SIZE,0,-1,GWkrgb(COLOUR_PURPLE),-1,NULL,0);
  GWputtxt(GAMEOVER_START_X,GAMEOVER_START_Y,(char*)"GAME OVER",0);
}

void stage::ShowCommand(void){
#define SHADOW_VOLUME_CONTINUE 1.6
#define COLOUR_MIDNIGHTBLUE 65,105,225
  GWsettxt(GAMEOVER_COMMAND_CHARA_SIZE,0,0,GWC_BLACK,-1,NULL,0);
  GWputtxt(WINDOW_WIDTH/2+SHADOW_VOLUME_CONTINUE,WINDOW_HEIGHT/2+MARGIN_COMMAND_Y-SHADOW_VOLUME_CONTINUE,(char*)"< Press C to continue >",0);
  GWsettxt(GAMEOVER_COMMAND_CHARA_SIZE,0,0,GWC_GREEN,-1,NULL,0);
  GWputtxt(WINDOW_WIDTH/2,WINDOW_HEIGHT/2+MARGIN_COMMAND_Y,(char*)"        C              ",0);
  GWsettxt(GAMEOVER_COMMAND_CHARA_SIZE,0,0,GWkrgb(COLOUR_MIDNIGHTBLUE),-1,NULL,0);
  GWputtxt(WINDOW_WIDTH/2,WINDOW_HEIGHT/2+MARGIN_COMMAND_Y,(char*)"< Press   to continue >",0);
}

void stage::UpdateTime(void){
  Time+=TimePeriod;
  sec=Time>>10;
  if(sec>59){
    sec=0;
    Time=0;
    min++;
  }
  if(sec!=presec) DrawStatusTime();
  presec=sec;
}

void stage::ScoreUp(char LineN,char columnSum){
  //XRǍvZ
  //root(ɏs*݂̃x)*{_+sԍ̘a2*0.1
  //Ƃŏ|Cg
  Score+=sqrt((float)LineN*Lv)*BASE_POINT+columnSum*columnSum*0.1;
  DrawStatusScore();
  if(Score-LEVEL_UP_POINTS*Lv>0) LvUp();
}

void stage::LvUp(void){
  if(Lv>254) return;
  Lv=Score/LEVEL_UP_POINTS+1;
  DrawStatusLevel();
  if(Lv<3) CntToNext=SPEED1;
  else if(Lv<5) CntToNext=SPEED2;
  else if(Lv<8) CntToNext=SPEED3;
  else if(Lv<10) CntToNext=SPEED4;
  else if(Lv<12) CntToNext=SPEED5;
  else if(Lv<14) CntToNext=SPEED6;
  else if(Lv<16) CntToNext=SPEED7;
  else if(Lv<18) CntToNext=SPEED8;
  else if(Lv<20) CntToNext=SPEED9;
  else if(Lv<22) CntToNext=SPEED10;
  else if(Lv<24) CntToNext=SPEED11;
  else CntToNext=SPEED12;
}

void stage::IncrementCnt(void){
  cnt++;
}

void stage::ResetCnt(void){
  cnt=0;
}

void stage::SetCntTTL(void){
  cnt=DEFAULT_CNT_TO_NEXT-TTL;
}

int stage::GetCnt(void){
  return cnt;
}

int stage::InitializeIsFilledArray(void){
  for(char r=1;r<ROW+1;r++){
    for(char c=1;c<=COLUMN+1+MARGIN_UP;c++){
      IsFilled[r][c]=false;
    }
  }
  for(char r=0;r<ROW+2;r++){
    IsFilled[r][0]=true;
  }
  for(char c=1;c<COLUMN+1+MARGIN_UP;c++){
    for(char r=0;r<ROW+2;r+=ROW+1){
      IsFilled[r][c]=true;
    }
  }
  return 0;
}

int stage::SetIsFilledArray(char row,char column,bool f){
  IsFilled[row][column]=f;
  return 0;
}

int stage::DrawNextCHARA(void){
  GWsettxt(NEXT_CHARA_SIZE,0,-1,GWC_LIGHTGRAY,-1,NULL,0);
  GWputtxt(NEXT_CHARA_START_X,NEXT_CHARA_START_Y,(char*)"NEXT",0);
  //GWsettxt(NEXT_CHARA_SIZE,0,-1,GWC_LIGHTGRAY,-1,NULL,0);
  return 0;
}

int stage::DrawStatus(void){
  /*  char temp[64];
  GWsettxt(NORMAL_CHARA_SIZE,0,-1,GWC_LIGHTGRAY,-1,NULL,0);
  sprintf(temp,"Time  : %-2dm %02d s",min,sec);
  GWputtxt(SCORE_CHARA_START_X,SCORE_CHARA_START_Y,temp,0);
  sprintf(temp,"Score : %-8d",Score);
  GWputtxt(SCORE_CHARA_START_X,SCORE_CHARA_START_Y+NORMAL_CHARA_SIZE+NORMAL_CHARA_INTERVAL,temp,0);
  sprintf(temp,"Level : %d",Lv);
  GWputtxt(SCORE_CHARA_START_X,SCORE_CHARA_START_Y+NORMAL_CHARA_SIZE*2+NORMAL_CHARA_INTERVAL*2,temp,0);
  */
  DrawStatusTime();
  DrawStatusScore();
  DrawStatusLevel();
  return 0;
}

int stage::DrawStatusTime(){
  char temp[64];
  GWerase(TIMEOGN,1);
  GWsettxt(NORMAL_CHARA_SIZE,0,-1,GWC_LIGHTGRAY,-1,NULL,0);
  sprintf(temp,"Time  : %-2dm %02d s",min,sec);
  GWsetogn(0,TIMEOGN);
  GWputtxt(SCORE_CHARA_START_X,SCORE_CHARA_START_Y,temp,0);
  return 0;
}

int stage::DrawStatusScore(){
  char temp[64];
  GWerase(SCOREOGN,1);
  GWsetogn(0,SCOREOGN);
  GWsettxt(NORMAL_CHARA_SIZE,0,-1,GWC_LIGHTGRAY,-1,NULL,0);
  sprintf(temp,"Score : %d",Score);
  GWputtxt(SCORE_CHARA_START_X,SCORE_CHARA_START_Y+NORMAL_CHARA_SIZE+NORMAL_CHARA_INTERVAL,temp,0);
  return 0;
}

int stage::DrawStatusLevel(){
  char temp[64];
  GWerase(LEVELOGN,1);
  GWsetogn(0,LEVELOGN);
  GWsettxt(NORMAL_CHARA_SIZE,0,-1,GWC_LIGHTGRAY,-1,NULL,0);
  sprintf(temp,"Level : %d",Lv);
  GWputtxt(SCORE_CHARA_START_X,SCORE_CHARA_START_Y+NORMAL_CHARA_SIZE*2+NORMAL_CHARA_INTERVAL*2,temp,0);
  return 0;
}


int stage::DrawInstruction(void){
  GWsettxt(LITTLE_CHARA_SIZE,0,-1,GWC_GREEN,-1,NULL,0);
  GWputtxt(INST_CHARA_START_X,INST_CHARA_START_Y+2*(LITTLE_CHARA_SIZE+LITTLE_CHARA_INTERVAL),(char*)"  @        S,",0);
  GWputtxt(INST_CHARA_START_X,INST_CHARA_START_Y+LITTLE_CHARA_SIZE+LITTLE_CHARA_INTERVAL,(char*)"Z,        X,        C,",0);
  GWputtxt(INST_CHARA_START_X,INST_CHARA_START_Y,(char*)"  @     @SPACE",0);
  GWsettxt(LITTLE_CHARA_SIZE,0,-1,GWC_DARKGRAY,-1,NULL,0);
  GWputtxt(INST_CHARA_START_X,INST_CHARA_START_Y+2*(LITTLE_CHARA_SIZE+LITTLE_CHARA_INTERVAL),(char*)"  @          @:Rotate",0);
  GWputtxt(INST_CHARA_START_X,INST_CHARA_START_Y+LITTLE_CHARA_SIZE+LITTLE_CHARA_INTERVAL,(char*)"  @:Left     @:Down     @:Right",0);
  GWputtxt(INST_CHARA_START_X,INST_CHARA_START_Y,(char*)"  @     @     :Drop",0);
  return 0;
}

bool stage::ReferFilledArray(char row,char column){
  return IsFilled[row][column];
}

int stage::InitializeWindow(void){
  static bool FIRST=true;
  GWopenx(0,0,0,GWC_WHITE,GWC_BLACK,-1,NULL,0);
#ifndef DEBUG
  GWmode(3,0);
#endif
  GWport(0,0,WINDOW_WIDTH,WINDOW_HEIGHT);
  GWindow(0,0,WINDOW_WIDTH,WINDOW_HEIGHT);
  int WW=WINDOW_WIDTH*1.2;
  int WH=WINDOW_HEIGHT*1.2;
  if(FIRST) GWsize(-3,&WW,&WH);
  FIRST=false;
#ifdef DEBUG
  GWrect(1,1,WINDOW_WIDTH,WINDOW_HEIGHT);
#endif
  return 0;
}

int stage::DrawOutline(void){
  //GWsrect(STAGE_START_X,STAGE_START_Y,STAGE_START_X+(ROW+2)*BLOCK_LENGTH,STAGE_START_Y+(COLUMN+2)*BLOCK_LENGTH,GWC_WHITE);
  GWsrect(STAGE_START_X+BLOCK_LENGTH,STAGE_START_Y+BLOCK_LENGTH,STAGE_START_X+(ROW+1)*BLOCK_LENGTH,STAGE_START_Y+(COLUMN+1)*BLOCK_LENGTH,GWkrgb(BACK_COLOUR));
  GWsetpen(GWC_WHITE,GWL_SOLID,2,-1);
  //GWline(STAGE_START_X+BLOCK_LENGTH*(ROW+4),STAGE_START_Y+BLOCK_LENGTH*(COLUMN/2+0.5),WINDOW_WIDTH-BLOCK_LENGTH*2,STAGE_START_Y+BLOCK_LENGTH*(COLUMN/2+0.5));
  GWsrect(STAGE_START_X+BLOCK_LENGTH*(ROW+5),STAGE_START_Y+BLOCK_LENGTH*(COLUMN+2-0.5),WINDOW_WIDTH-BLOCK_LENGTH*3.5,STAGE_START_Y+(COLUMN/2+3)*BLOCK_LENGTH,GWkrgb(32,32,32));
  GWsrect(STAGE_START_X+BLOCK_LENGTH*(ROW+5),STAGE_START_Y+BLOCK_LENGTH*(COLUMN+2-3),WINDOW_WIDTH-BLOCK_LENGTH*3.5,STAGE_START_Y+(COLUMN/2+3)*BLOCK_LENGTH,GWkrgb(16,16,16));
  DrawInstruction();
  return 0;
}

int stage::DrawGrid(void){
  float x1=STAGE_START_X+BLOCK_LENGTH;
  float x2=STAGE_START_X+BLOCK_LENGTH*(ROW+1);
  float y1=STAGE_START_Y+BLOCK_LENGTH;
  float y2=STAGE_START_Y+BLOCK_LENGTH*(COLUMN+1);
  GWsetpen(GWkrgb(GRID_COLOUR),GWL_DOT,0,-1);
  for(char column=1;column<COLUMN;column++){
    GWline(x1,y1+BLOCK_LENGTH*column,x2,y1+BLOCK_LENGTH*column);
  }
  for(char row=1;row<ROW;row++){
    GWline(x1+BLOCK_LENGTH*row,y1,x1+BLOCK_LENGTH*row,y2);
  }
  return 0;
}
